// ==ANONUserScript==
// @file        anon_fleet1.js
// @name        anon_fleet1
// @description Enhances Fleet page 1, with cargo space, ships needed to take resources, ...
// @author      SolarAngel (SA) <furry[you know what comes here]tesla.rcub.bg.ac.yu>
// @include     http://uni*.ogame.*/game/flotten1.php?session=*&mode=Flotte*
// ==/ANONUserScript==

//*****************************************************************************************
// parseInt fix to always parse value in system of 10
//
var _parseInt = function(string, system){ return parseInt(string, system||10); };

//*****************************************************************************************

function isNumber(a) {
  return typeof a == 'number' && isFinite(a);
}

//*****************************************************************************************
// don't ask, I know I am insane ;)
function formatNumber(n,p,g){
  var b=n<0,a=new Array(),v='';p=p||'.';g=g||3;
  var s=(b?(v+n).substring(1):v+n).split(v).reverse().join(v);
  for(var i=0;i<s.length;i+=g)a[Math.ceil(i/g)]=s.substring(i,i+g);
  return (b?'-':v)+a.join(p).split(v).reverse().join(v);
};

function formatNumberRe(n,p,g) {
  n+='';p='$1'+(p||'.')+'$2';g=g||3;
  var re = new RegExp('(\\d+)(\\d{'+g+'})','');
  while (re.test(n)) n=n.replace(re, p);
  return n;
}
//*****************************************************************************************

function ShowCapacity() {
  try {
    var input       = document.getElementsByTagName('input');
    var capic       = 0;
    var maxships;
    var shipNumber;
    var shipCargo;

    for(var i=0; i< input.length;i++)
    {
      var item = input[i];
      if (
          item.getAttribute &&
          item.getAttribute('name') &&
          item.getAttribute('name').substr(0,4)=='ship'
         )
      {
        var name = item.getAttribute('name');
        if (name!='ship210'){
          maxships = parseInt(document.getElementsByName('max'+name)[0].value);
          shipCargo = parseInt(document.getElementsByName('capacity'+name.substr(4))[0].value);
          shipNumber = parseInt(item.value);

          if(shipNumber>maxships){
            shipNumber = maxships;
            item.style.border = 'red 1px solid';
          }else{
            item.style.border = null;
          };
          if(isNumber(shipNumber)) capic+=shipNumber*shipCargo;
        };
      };
    };
    capic = capic<0?0:capic;

    // NOW WHERE TO INSERT (find cell with "-" text in it, and add capacity to next cell)
    var obj = document.evaluate('//table[@width="519"]/descendant::tr[@height="20"]/th[3]',document,null,
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    for(var i=0; i<obj.snapshotLength; i++)
    {
      if(obj.snapshotItem(i).textContent=='-'&&obj.snapshotItem(i).previousSibling.previousSibling.textContent!='-')
      {

        if(window.opera){
          obj = obj.snapshotItem(i).nextSibling;
        }else{
          // FF DOM: 1st nextSibling is [#TEXT] node
          obj = obj.snapshotItem(i).nextSibling.nextSibling;
        };
        obj.innerHTML = formatNumber(capic);
        obj.style.cssText = 'color:lime; text-align:center;';
        break;

      };
    };

  }catch(e){ _postError(e, 'anon_fleet1::ShowCapacity'); }
};// end ShowCapacity();

//*****************************************************************************************


  try {
    input = document.getElementsByTagName('input');
    for(var i=0; i< input.length;i++)
    {
      var item = input[i];
      if (
           item.getAttribute &&
           item.getAttribute('name') &&
           item.getAttribute('name').substr(0,4)=='ship'
         )
      {
        if(window.opera){
          item.onkeyup  = 'ShowCapacity();';
          item.onchange = 'ShowCapacity();';
        }else{
          item.setAttribute('onkeyup',  'ShowCapacity();');
          item.setAttribute('onchange', 'ShowCapacity();');
        };
      };
    };

    ahref = document.getElementsByTagName('a');
    for(var i=0; i< ahref.length;i++)
    {
      if(ahref[i])
      {
        if (ahref[i].href.match('maxShip') || ahref[i].href.match('noShip') )
        ahref[i].href = ahref[i].href + ';ShowCapacity();';
      };
    };
    ShowCapacity();
  }catch(e){ _postError(e,'anon_fleet1::ShowCapacityParse'); };
