//*****************************************************************************************
// Galaxy Features functions
//*****************************************************************************************

//*****************************************************************************************
function fg_addDebrisImage(document) {

	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightBigDebris",true)) return;	

	if (fg_Debug) alert("Estamos escombros");

	try {

	      var path = '//table[@width="569"]/child::tbody/descendant::tr/child::th[1]/child::a[2]';
      	var obj = fgEval(path,document);

		try {
			var color = PrefsBranchFG.getCharPref("fgDebrisColor");
		} catch(e) { var color ="#AA3333";}

		try {
			var min = PrefsBranchFG.getCharPref("fgDebrisMin");
		} catch(e) { var min ="20000";}

		min = fg_parseInt(min);

		var title, metal, cristal;
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj2 = obj.snapshotItem(i);
			title = obj2.getAttribute("title");
			title = title.split(':');
			if (title.length < 2){
				title = title[0].split(' ');
				metal = title[3].replace(/[\s\.]/gi,'');
				cristal = title[6].replace(/[\s\.]/gi,'');				
			} else {
				metal = title[2].split(',');
				metal = metal[0].replace(/[\s\.]/gi,'');
				cristal = title[3].replace(/[\s\.]/gi,'');
			}
			if (fg_parseInt(metal) + fg_parseInt(cristal) >= min) {
				obj2.parentNode.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.setAttribute("style", "background-color : "+color+"; background-image : none;");
			}	
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_removePlanets(document) {
	
	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameRemovePlanets",true)) return;
	
	if (fg_Debug) alert("Estamos planets");
	

	try {
	      var path = '//table[@width="569"]/child::tbody/child::tr/child::th[position()=2]';
      	var obj = fgEval(path,document);		
	
		if (obj.snapshotLength == 0) return;

		var text;
		var max = obj.snapshotLength;
		if (obj.snapshotLength > 15)
			max = 15;
		for (var i = 0; i < max; i++) {
			if (obj.snapshotItem(i).firstChild.nextSibling != null) {
				text = obj.snapshotItem(i).nextSibling.nextSibling.innerHTML;			
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = "";
				obj.snapshotItem(i).nextSibling.nextSibling.appendChild(
					obj.snapshotItem(i).removeChild(obj.snapshotItem(i).firstChild.nextSibling));
				obj.snapshotItem(i).nextSibling.nextSibling.firstChild.innerHTML = text;
			}
			
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}
		if (obj.snapshotLength > 15)
			obj.snapshotItem(15).setAttribute("colspan","6");
			
	    path = '//table[@width="569"]/descendant::td[@class="c"][position()=2]';
      	obj = fgEval(path,document);		
		
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (i == 0) {
				text = obj.snapshotItem(i).innerHTML;
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = text;
			}
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	    path = '//table[@width="569"]/descendant::td[@class="c"][position()=5]';
      	obj = fgEval(path,document);
		obj.snapshotItem(0).innerHTML = messages.GetStringFromName("foxgame.inner.reducedDebris");
		
	    path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="8"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","7");
		}
	    path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="6"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","5");
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addMilosButtons(document) {

	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	
//	if (GT_isLoaded && typeof(GT_processGalaxy) == function) GT_processGalaxy();
	
	if (!fgGetBooleanPref("foxgameAddMilosButtons",false)) return;
	
	if (fg_Debug) alert("Estamos milos");
	
	try {
//Insertamos el .js con la funcion de envio del formulario
	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosGalaxy.js");

// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="569"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;
		
	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];
	var text = "";

	if (ele.type == "OGSpy") {
		
		var Selection = window.getSelection();
		if(Selection.rangeCount > 0) Selection.removeAllRanges();

	     	var range = document.createRange();
	      range.selectNode(obj.snapshotItem(0));
		Selection.addRange(range);

	      var path = '//div[starts-with(@id,"tOoLtIp")]';
      	var obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
		     	var range = document.createRange();
		      range.selectNode(obj.snapshotItem(i));
			Selection.addRange(range);

		}
		texto = Selection.toString();

	} else if (ele.type != "GalaxieTool") {
		obj = obj.snapshotItem(0);
		var tr = obj.firstChild.nextSibling.firstChild;
      	var range = document.createRange();
	
	      //range.selectNode(obj);
		//var text = range.toString();

		while (tr != null)
	 	{
			if (tr.nodeName == 'TR') {
				var td = tr.firstChild;
				while (td != null) {
					if (td.nodeName == 'TD' || td.nodeName == 'TH')
					{
							var a = fgEvalnode('.//img[contains(@alt,"M")]',document,td);
							if (a.snapshotLength > 0) 
								text += "M \t";
							else {
							      range.selectNode(td);
								text += range.toString().retrim()+" \t";
							}
					}
					td = td.nextSibling;
				}
				text = text.substr(0,text.length-2)+"\n";
			}
			tr = tr.nextSibling;
		}
		range.detach;
		texto = text;
	} else {
		texto = fg_GTPlugin_get_galaxyview_data(document);
		//obj.snapshotItem(0).innerHTML;
		//texto = texto.replace(/'/ig,"");
	}
	

	//Insertamos un formulario para poder enviar los datos directamente.	
	// StalkR REPLACE START
	// this is for compactifying the galaxy top menu: put OGSpy buttons at the very top, on the right
	/*var form = document.createElement('tr');
	var td = document.createElement('td');
	td.setAttribute("colspan","8");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");*/
	// StalkR REPLACE WITH
	// get the TR that contains the galaxy head with 'galaxy' and 'system' fields and 'show' button
	var path = '//form/child::table/child::tbody/child::tr';
	var obj = fgEval(path,document);
	if (obj.snapshotLength == 0) return;
	// and writes our top menu
	var ttd = document.createElement("td");
	obj.snapshotItem(0).appendChild(ttd);
	var ttbl = document.createElement("table");
	ttd.appendChild(ttbl);
	var ttr1 = document.createElement("tr");
	var ttr2 = document.createElement("tr");
	ttbl.appendChild(ttr1);
	ttbl.appendChild(ttr2);
	var td1 = document.createElement("td");
	td1.setAttribute("class","c");
	td1.innerHTML = ele.type;
	ttr1.appendChild(td1);
	var td2 = document.createElement("td");
	td2.setAttribute("class","l");
	td2.setAttribute("align","center");
	ttr2.appendChild(td2);
	// now create separately the table containing the MilosDiv & form data, at the very end of the page
	var mdtbl = document.createElement('table');
	document.getElementsByTagName("body")[0].appendChild(mdtbl);
	var form = document.createElement('tr');
	mdtbl.appendChild(form);
	var td = document.createElement('td');
	// StalkR REPLACE END

	td.innerHTML = fg_MilosDiv;
	if (ele.type == "Milos") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
				'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
				'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
				'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
				'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
				'<input type=hidden name="milos_login[r]" value="">'+
				'<input type=hidden name="show" value="checked">'+
				'<input type=hidden name="noncommit" value="">'+
				'<input type=hidden name="delafter" value="checked">'+
				'<input type=hidden name=x value="'+texto+'">';
	}
	else if (ele.type == "EspRep") {
			td.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form" accept-charset="utf-8">'+
				'<input type=hidden name="show" value="Process Dump (Show Results)">'+
				'<input type="hidden" name="espplayer" value="none">'+
				'<input type="hidden" name="espalliance" value="none">'+
				'<input type=hidden name=dump value="'+texto+'">';
	}
	else if (ele.type == "OGSpy") {
			td.innerHTML += '<form action="'+ele.other+'" method=post target="_milos" id="milos_form" >'+
				'<input type=hidden name="action" value="get_data">'+
				'<input type="hidden" name="datatype" value="basic">'+
				//'<textarea name=data rows=1 cols=75>'+texto+'</textarea>';
				'<input type=hidden name=data value="'+texto+'">';
	}
	else if(ele.type == "GalaxieTool") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form">'+
			//td.innerHTML += '<form action="'+temp[2]+'" method=post target="_blank" id="milos_form">'+
				'<input type=hidden name="user" value="'+temp[0]+'">'+
				'<input type=hidden name="password" value="'+temp[1]+'">'+
				'<input type=hidden name="typ" value="galaxy">'+
				'<input type=hidden name="galaxy" value="'+document.getElementsByName("galaxy")[0].value+'">'+
				'<input type=hidden name="system" value="'+document.getElementsByName("system")[0].value+'">'+
				//"<textarea name=content rows=1 cols=75 name='content'>"+texto+"</textarea>";
				"<input type=hidden name='content' value='"+texto+"'>";		
	}
	// StalkR REPLACE START
	/*td.innerHTML += "<input type=button value=\"&lt;- "+ele.type+"\" onClick=\"next('l:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+"\" onClick=\"next('1:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+" -&gt;\" onClick=\"next('r:"+ele.type+"')\">";*/
	// StalkR REPLACE WITH
	// compactify the buttons into just: "< | o | >" instead of the large "<- type | type | type ->"
	td2.innerHTML += "<input type=button value=\"&lt;\" onClick=\"next('l:"+ele.type+"')\">"+
	"<input type=button value=\"o\" onClick=\"next('1:"+ele.type+"')\">"+
	"<input type=button value=\"&gt;\" onClick=\"next('r:"+ele.type+"')\">";
	// StalkR REPLACE END
		
	form.appendChild(td);

	// StalkR DELETE START
	// no longer used since already added to the page (at the top)
	/* var tds = fgEval('//table[@width="569"]/tbody', document);
	if (tds.snapshotLength > 0)
		tds.snapshotItem(0).insertBefore(form,tds.snapshotItem(0).firstChild);	*/
	// StalkR DELETE END	


	} catch (e) {
		foxgamedebug(e);
	}
}

//*****************************************************************************************
function fg_addDebrisNumbers(document) {

   if (document && !fg_isGalaxyUrl(document.location.href)) return;
   if (!fgGetBooleanPref("foxgameAddDebrisNumbers",false)) return;
   
   if (fg_Debug) alert("fg_addDebris#");

   try {

      var path = '//table[@width="569"]/descendant::tr/th[5]/a[1]';
      var path2 = '//table[@width="569"]/descendant::tr/th[5]/a[1]/ancestor::tr/th[1]/a[@title]';
      var numberMatch = new RegExp("[0-9\.]+", "g");
      var obj = fgEval(path,document);
      var objText = fgEval(path2,document);
	if (objText.snapshotLength != obj.snapshotLength)
		return;
	var results, text, obj2, obj2_5, childs, span, font;
      for (var i = 0; i < obj.snapshotLength; i++) {
         obj2 = obj.snapshotItem(i);
	   obj2_5 = objText.snapshotItem(i);
	   text = obj2_5.getAttribute('title');
	   results = text.match(numberMatch);
	   span = document.createElement("span");
	   span.setAttribute("class","debrisText");
	   span.appendChild(document.createTextNode(results[0]));
	   span.appendChild(document.createElement('br'));
	   span.appendChild(document.createTextNode(results[1]));
    	   font = document.createElement("font");
    	   font.setAttribute("size","-2");
	   font.appendChild(span);
         childs = obj2.childNodes;
	   while(childs.length != 0)
		obj2.removeChild(obj2.firstChild);
	   obj2.appendChild(font);
      }
   } catch (e) {
      foxgamedebug(e);
   }
}

//*****************************************************************************************
function fg_addPhalanxIndicator(document) {

   if (document && !fg_isGalaxyUrl(document.location.href)) return;
   if (!fgGetBooleanPref("foxgameAddPhalanxIndicator",true)) return;
   if (fg_Debug) alert("fg_addPhalanxInd");

   try {

      var path = '//table[@width="569"]/descendant::tr/th[3]/a[starts-with(@onclick,"fenster(")]';
      var obj = fgEval(path,document);
	if (obj.snapshotLength == 0)
		return;
      path = '//table[@width="569"]/descendant::tr/td[@class="c"][@colspan="8"]';
      obj = fgEval(path,document);
   	img = document.createElement("img");
	img.setAttribute("src","chrome://foxgame/content/resources/images/online.gif");
	img.setAttribute("align","right");
      obj.snapshotItem(0).appendChild(img);
   } catch (e) {
      foxgamedebug(e);
   }
}

//*****************************************************************************************
function fg_addPlayerRank(document) {

   if (document && !fg_isGalaxyUrl(document.location.href)) return;
   if (!fgGetBooleanPref("foxgameShowPlayerRank",false)) return;
   if (fg_Debug) alert("fg_addPlayerRank");

   try {

      var path = '//table[@width="569"]/descendant::tr/th[6]/a[1]';
      var obj = fgEval(path,document);

      var playerName, mouseover, flagsAndRank, startname, endname, endpos, spacepos, ranknode, rank;
      for (var i = 0; i < obj.snapshotLength; i++) {
         var obj2 = obj.snapshotItem(i);
         var playerCell = obj2.innerHTML;
         playerName = playerCell.stripHTMLEntities().trim();
         mouseover  = obj2.getAttribute("onmouseover");

         // Find the player-name as a starting point
         startname = mouseover.indexOf(playerName);
         if (startname != -1) {
            endname = startname+playerName.length
            // Find &lt; after the rank number
            endpos = mouseover.indexOf('<', endname);
            if (endpos != -1) {
               // Now we have the pop-up header
               flagsAndRank = mouseover.substr(endname, endpos-endname);

               // Get the rank number after the last space
               spacepos = flagsAndRank.lastIndexOf(' ');
               if (spacepos != -1) {
                  rank = flagsAndRank.substr(spacepos+1);
                  var font = document.createElement("font");
                  font.setAttribute("color","orange");
                  font.setAttribute("size","smaller");
			var span = document.createElement("span");
                  span.setAttribute("class","rank");
                  ranknode = document.createTextNode('#'+rank);
                  font.appendChild(span);
                  span.appendChild(ranknode);
                  obj2.parentNode.appendChild(font);
               }
            }
         }
      }
   } catch (e) {
      foxgamedebug(e);
   }
}
//*****************************************************************************************
function fg_addAllianceRank(document) {

   if (document && !fg_isGalaxyUrl(document.location.href)) return;
   if (!fgGetBooleanPref("foxgameShowAllyRank",false)) return;
   if (fg_Debug) alert("fg_addAllianceRank");

   try {

      var path = '//table[@width="569"]/descendant::tr/th[7]/a[1]';
      var obj = fgEval(path,document);

      var allianceName, mouseover, flagsAndRank, startname, endname, endpos, spacepos, ranknode, rank;
      for (var i = 0; i < obj.snapshotLength; i++) {
         var obj2 = obj.snapshotItem(i);
         var allianceCell = obj2.innerHTML;
         allianceName = allianceCell.stripHTMLEntities().trim();
         mouseover  = obj2.getAttribute("onmouseover");

         // Trim white-spaces
         allianceName = allianceName.trim();

         if (allianceName.length > 0) {
            mouseover  = obj2.getAttribute("onmouseover");

            // Find the player-name as a starting point
            startname = mouseover.indexOf(allianceName);
            if (startname != -1) {
               endname = startname+allianceName.length
               // Find &lt; after the rank number
               endpos = mouseover.indexOf('<', endname);
               if (endpos != -1) {
                  // Now we have the pop-up header
                  rankText = mouseover.substr(endname, endpos-endname);

                  // Get the rank numbers
                  var numberMatch = new RegExp("[0-9]+", "g");
                  results = rankText.match(numberMatch);

                  if (results != null && results.length == 2) {
                     rank = "#"+results[0]+"/"+results[1];

                     var font = document.createElement("font");
                     font.setAttribute("color","orange");
                     font.setAttribute("size","smaller");
			   var span = document.createElement("span");
                     span.setAttribute("class","rank");
                     ranknode = document.createTextNode(rank);
                     font.appendChild(span);
                     span.appendChild(ranknode);
                     obj2.parentNode.appendChild(font);

                  }
               }
            }
         }   
      }
   } catch (e) {
      foxgamedebug(e);
   }
} 
