// ==ANONUserScript==
// @file        anon_prodpercent.js
// @name        anon_prodpercent
// @description adds graphic display of building / research progres (Real-Time)
// @author      SolarAngel (SA) <furry[you know what comes here]tesla.rcub.bg.ac.yu>
// @include     http://*/game/index.php?page=b_building&*
// @include     http://*/game/index.php?page=buildings&session=*&mode=Forschung
// ==/ANONUserScript==

var pageType = 0;
(function(){
  try {
    if (!document.getElementById('bxx')) return;

    var m, td, pro, divOut, divIn, time = 0, totalTime = 0;
    var reTimeLeftBuilding = /pp\=\'(\d+)\'\;/igm;
    var reTimeLeftResearch = /ss\=(\d+)\;/igm;

    var scripts = document.getElementsByTagName('script');
    for(var i=scripts.length-1;i>=0;i--){
      m = scripts[i].innerHTML.match(reTimeLeftBuilding);
      if(m){ time = m[0].replace(reTimeLeftBuilding,'$1'); break; }
      m = scripts[i].innerHTML.match(reTimeLeftResearch);
      if(m){ time = m[0].replace(reTimeLeftResearch,'$1'); pageType=1; break; }
    }

    td = document.getElementById('bxx').parentNode.previousSibling;
    m = td.innerHTML.split(/<br>/i);
    for (var i=m.length-1;i>=0;i--)
      if(m[i].indexOf(':')!=-1){
        totalTime = m[i].split(':')[1];
        break;
      }
    m = totalTime.match(/(\d+)/igm);
         if(m.length==4) totalTime=(m[0]*24*3600)+(m[1]*3600)+(m[2]*60)+(m[3]*1);
    else if(m.length==3) totalTime=(m[0]*3600)+(m[1]*60)+(m[2]*1);
    else if(m.length==2) totalTime=(m[0]*60)+(m[1]*1);
    else if(m.length==1) totalTime=(m[0]*1);
    if (totalTime<time){ // missing seconds in total time
           if(m.length==3) totalTime=(m[0]*24*3600)+(m[1]*3600)+(m[2]*60);
      else if(m.length==2) totalTime=(m[0]*3600)+(m[1]*60);
      else if(m.length==1) totalTime=(m[0]*60);
    }

    if(td && totalTime && time) {
      pro = new String((totalTime-time)*100/totalTime)
      pro = pro.replace(/(\d+\.[\d]{0,2})\d+/,'$1');
      divTop = document.createElement('div');
      divIn = document.createElement('div');
      divIn.setAttribute('totalTime',totalTime);
      divIn.setAttribute('id','divProdPercent');
      divIn.textContent = ''+pro+'%';
      divTop.appendChild(divIn);
      td.appendChild(divTop);
      divTop.style.cssText = 'width:99%; height:13px;\
                              border:1px #0c0 solid;\
                              background-color:#000;';
      divIn.style.cssText = 'width:'+pro+'%; height:13px;\
                             font-size:10px; font-weight:700;\
                             text-align:center; color:#555;\
                             background-color:#dfd;';
      setTimeout(prodPercentUpdate,999);
    }//else{alert('td:'+td+'\ntime:'+time+'\nallTime:'+allTime);}

  }catch(e){ _postError(e, 'productionPercent'); }

})();

function prodPercentUpdate(){
  var div = document.getElementById('divProdPercent');
  if (div){
    var time=0;
    if (pageType==0) time=pp; else time=ss-Math.round((new Date().getTime()-v.getTime())/1000.);
    var totalTime = div.getAttribute('totalTime',0);
    var p = new String((totalTime-time)*100/totalTime)
        p = p.replace(/(\d+\.[\d]{0,2})\d+/,'$1');

    if (div.getAttribute('percent')!=p){
      div.setAttribute('percent',p);
      div.style.width=parseInt(p)+'%';
      div.textContent = ''+(p>100?100:p)+'%';
    }
    setTimeout(prodPercentUpdate,1999);
  }
}
